;#######################################################
;#  Title      		: BGS DATA LOGGER        		   # 
;#	Description 	: 5 INPUT ENGINE SENSOR DATA       #
;#   				  RECORDER                         #
;#	Author			: A WALCH 18TH JAN 2009			   #
;#######################################################

		 #INCLUDE<P16F877A.INC>
		__CONFIG _DEBUG_OFF&_CP_ALL&_WRT_HALF&_CPD_ON&_LVP_OFF&_BODEN_OFF&_PWRTE_ON&_WDT_OFF&_HS_OSC
		errorlevel -305,-207,-302
;*******************************************************


		count	equ	30	; Counter for ADC setup delay
		ADbin	equ	31	; Binary input value
		huns	equ	32	; Hundreds digit in decimal value
		tens	equ	33	; Tens digit in decimal value
		ones	equ	34	; Ones digit in decimal value
		pc		equ 35
	
		VAL_US   	EQU .249               ;short delay parameter
		VAL_MS   	EQU	.100               ;long delay parameter   
		COUNT    	EQU 0x25
		COUNT_MS 	EQU	0x26
		
		ORG		0x000
		;nop
		goto	init
		ORG     04H                      ;interrupt entrance address
		bsf		PORTC,0 
		BTFSS   PIR1,RCIF                 ;judge if COMM receive interrupt     
		GOTO    EXIT                      ;no, jump to interrupt end program   
		MOVF    RCREG,0                   ;read data of receive register       
		MOVWF   TXREG                     ;keep in send register and send      
		EXIT
			retfie   
;*******************************************************

;*******************************************************
init        
 ;BANKSEL TRISC                     ;select BANK1                        
 ;BSF     TRISC,7                   ;disconnect RC and USART TX          
 ;BSF     TRISC,6                   ;disconnect RC and USART RX          
 ;MOVLW   0CH                       ;load band rate=19.2kbd              
 ;MOVWF   SPBRG                                                          
 ;MOVLW   24H                       ;enable USART,set band rate is high  
 ;MOVWF   TXSTA                                                          
 ;BSF     PIE1,RCIE                 ;enable receive interrupt            
 ;CLRF    STATUS                    ;select BANK0                        
 ;MOVLW   90H                                                            
 ;MOVWF   RCSTA                     ;enable USART continue receive       
 ;BSF     INTCON,GIE                ;enable general interrupt            
 ;BSF     INTCON,PEIE               ;enable outside interrupt  

		BANKSEL	TRISA
		movlw	b'00001010'
		movwf	ADCON1
				
		movlw	b'00000000'
		movwf	TRISC
		movwf	TRISD
		movlw	b'00000111'			;Set RE0...RE2 to analog inputs
		movwf	TRISE
	
		BSF     TRISC,7                   ;disconnect RC and USART TX          
		BSF     TRISC,6                   ;disconnect RC and USART RX          
		MOVLW   0CH                       ;load band rate=19.2kbd              
		MOVWF   SPBRG                                                          
		MOVLW   24H                       ;enable USART,set band rate is high  
		MOVWF   TXSTA                                                          
		BSF     PIE1,RCIE                 ;enable receive interrupt     

    		
		BANKSEL	PORTA
		bsf		ADCON0,ADCS0	;Sets Fosc/8
		bcf		ADCON0,CHS2		;
		bcf		ADCON0,CHS1		;
		bcf		ADCON0,CHS0		;Select port to read (RA0 default)
		bsf		ADCON0,ADON		;Enable A/D
	 
		CLRF    STATUS                    ;select BANK0                        
		MOVLW   90H                                                            
		MOVWF   RCSTA                     ;enable USART continue receive       
		BSF     INTCON,GIE                ;enable general interrupt            
		BSF     INTCON,PEIE               ;enable outside interrupt  

		clrf	PORTE
		;clrf	PORTC

;*******************************************************
main	
 CALL    DELAY_US                  ;call two delay program              
 CALL    DELAY_US    
		
loop		
		bcf		ADCON0,CHS2		;
		bcf		ADCON0,CHS1		;
		bcf		ADCON0,CHS0		;Select port to read (RA0 default)
		
		call	adc_conversion
		call	condec
movlw	0x2A
movwf	TXREG
CALL    DELAY_US 
CALL    DELAY_US 
movlw	0x31
movwf	TXREG
CALL    DELAY_US 
CALL    DELAY_US 
movlw	0x2A
movwf	TXREG
CALL    DELAY_US 
CALL    DELAY_US 


		;movlw	0x8B			;mov pointer to last pos
		;call	disp_pos_x
		movf	huns,w
		movwf	TXREG
 CALL    DELAY_US 
 CALL    DELAY_US 
		;call	send_to_lcd
		;movlw	0x8D			;mov pointer to last pos
		;call	disp_pos_x
		movf	tens,w
		movwf	TXREG
 CALL    DELAY_US 
 CALL    DELAY_US 
		;call	send_to_lcd
		movf	ones,w
		movwf	TXREG
 CALL    DELAY_US 
 CALL    DELAY_US 
		;call	send_to_lcd
 CALL    DELAY_MS 
 CALL    DELAY_MS 
movlw	0x2A
movwf	TXREG
CALL    DELAY_US 
CALL    DELAY_US 
movlw	0x32
movwf	TXREG
CALL    DELAY_US 
CALL    DELAY_US 
movlw	0x2A
movwf	TXREG
CALL    DELAY_US 
CALL    DELAY_US 
		bsf		ADCON0,CHS2		;
		bcf		ADCON0,CHS1		;
		bsf		ADCON0,CHS0		;Select port to read (RA0 default)

		call	adc_conversion
		call	condec
		;movlw	0xCB			;mov pointer to last pos
		;call	disp_pos_x
		movf	huns,w
		movwf	TXREG
 CALL    DELAY_US 
 CALL    DELAY_US 
		;call	send_to_lcd
		;movlw	0xCD			;mov pointer to last pos
		;call	disp_pos_x
		movf	tens,w
		movwf	TXREG
 CALL    DELAY_US 
 CALL    DELAY_US 
		;call	send_to_lcd
		movf	ones,w
		;call	send_to_lcd
		movwf	TXREG
 CALL    DELAY_US 
 CALL    DELAY_US 
		goto	loop
;*******************************************************
adc_conversion
		call 	delay_20us		;allow sample and hold circuit to settle
		bsf		ADCON0,GO
wait		
		btfsc	ADCON0,GO
		goto	wait
		movf	ADRESH,W
		return
;*******************************************************
; Convert input to decimal ................................

condec		
		movwf	ADbin		; get ADC result
		clrf	huns		; zero hundreds digit
		clrf	tens		; zero tens digit
		clrf	ones		; zero ones digit

; Calclulate hundreds......................................

		bsf		STATUS,C	; set carry for subtract
		movlw	D'100'		; load 100
sub1		
		subwf	ADbin		; and subtract from result
		incf	huns		; count number of loops
		btfsc	STATUS,C	; and check if done
		goto	sub1		; no, carry on
	
		addwf	ADbin		; yes, add 100 back on
		decf	huns		; and correct loop count

; Calculate tens digit.....................................

		bsf	STATUS,C	; repeat process for tens
		movlw	D'10'		; load 10
sub2		
		subwf	ADbin		; and subtract from result
		incf	tens		; count number of loops
		btfsc	STATUS,C	; and check if done
		goto	sub2		; no, carry on
	
		addwf	ADbin		; yes, add 100 back on
		decf	tens		; and correct loop count
		movf	ADbin,W		; load remainder
		movwf	ones		; and store as ones digit
	
		movlw	030
		addwf	huns
		addwf	tens		
		addwf	ones

		return			; done
;*******************************************************
delay_20us
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			return
;*******************************************************
DELAY_MS
 movlw   VAL_MS
 movwf   COUNT_MS
LOOP_MS
 call    DELAY_US
 decfsz  COUNT_MS,1
 goto    LOOP_MS
 return

;************************100us delay program**************
DELAY_US
 movlw   VAL_US
 movwf   COUNT
LOOP_US
 nop
 decfsz  COUNT,1
 goto    LOOP_US
 return

DELAY_S
 movlw   0FFH
 movwf   50H
 call    DELAY_MS
 decfsz  50H,1
 goto    $-2
 return
			end